C
C	HLADAJ
C
C     THIS PROGRAM SELECTS THOSE LINES FROM THE SAMPLE WHICH
C     HAVE MAJOR CONTRIBUTION TO THE TOTAL
C     RADIATIVE ACCELERATION TRANSFERRED TO THE ION THROUGH
C     BOUND-BOUND TRANSITIONS
C
C       INPUT:
C               hladaj.in (10)
C               A FILE WITH LINE LIST (11)
C		KURUCZ MODEL (13)
C       OUTPUT:
C               *.ION (21-29)
C               hladaj.out (12)
C     METHOD:
C       FOR EACH LINE TWO PARAMETERS RA_1,2 ARE COMPUTED. 
C	THEY ARE APPROXIMATE RAD.ACCELERATION CORRESPONDING TO 
C       TWO DIFFERENT TEMPERATURES T_1,2 (MINIMAL AND MAXIMAL) 
C	AT WHICH THE ION IS STILL RELATIVELY POPULATED. 
C	THESE PARAMETERS ARE THEN SUMMED FOR ALL THE LINES 
C	OF THE ION (SUMTOT_12 IN THE 'hladaj.out') AND
C	IN THE NEX ITERATIONS PROGRAM OMITS
C	THE WEAKEST LINES WITH RA_1,2<CRA_1,2 (A CLIP FOR RA_1,2) 
C	AND CALCULATES NEW SUM (SUMRA_12) AND ITERATES
C	UNTIL DSUMRA_12=(SUMRA_12-SUMTOT_12)/SUMTOT_12 REACHES 
C	PRESCRIBED VALUE.
C	THIS VALUES ARE GENERALY 1.E-2,1.E-3 AND YOU MUST SPECIFY
C	IT IN THE 'hladaj.in' EACH ION IS IN SEPARATE LINE.
C     
C	WORKS WITH NEW KURUCZ LTE MODELS ONLY
C
        PARAMETER (NDIM=72)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        CHARACTER*30 INLIN,INION,INMOD
	LOGICAL SIDE,SIDE1
C        CHARACTER*24 A7
        DIMENSION TEP(9,2),TEP1(9,2),I12(9,2),CRA(9,2),INION(9)
     P  ,DSUMRA(9,2),DSUM(9,2),CRA0(9,2)
     P  ,SUMRA(9,2),SUMTOT(9,2),DTDR(9,2),DENS(9,2),ROSS(9,2)
     P  ,VDM(NDIM),VHLB(NDIM),VTEP(NDIM),VTLAK(NDIM),VEKONC(NDIM)
     P  ,VAKONC(NDIM),VDENS(NDIM),ABROSS(NDIM)
        DATA INION/'1.ION','2.ION','3.ION','4.ION','5.ION','6.ION'
     P   ,'7.ION','8.ION','9.ION'/
C
C	SUMTOT - SUM OF ALL RA
C	SUMRA - SUM OF RA AFTER EXCLUDING RA<CRA
C	DSUMRA - (SUMTOT-SUMRA)/SUMTOT
C	DSUM - REQUIRED DSUMRA
C	CRA - A CLIP FOR RADIATIVE ACCELERATION
C
C        WRITE(6,'(A,$)')'NEW KURUCZ [0] OR HUBENY MODEL [1] => '
C        READ(5,*)IMODEL
        WRITE(6,'(A,$)')'WHICH ION TO SORT OUT [NEUTRAL=1,...] => '
        READ(5,*)IION
        WRITE(6,'(A,$)')'INPUT FILE WITH THE NEW KURUCZ MODEL => '
        READ(5,10)INMOD
10      FORMAT(A30)
        OPEN(10,FILE='hladaj.in',STATUS='OLD')
        I=1
        READ(10,*)
C	EFFECTIVE TEMPERATURE OF THE MODEL, MASS NUMBER OF THE ELEMENT
        READ(10,*)TEFF,HCP
        READ(10,*)
C	TEP1 - CHARACTERISTIC TEMPERATURES
20      READ(10,*,END=30)POMOC,TEP1(I,1),POMOC,TEP1(I,2)
     P  ,DSUM(I,1),DSUM(I,2)
        NION=I
        I=I+1
        GOTO 20
30      CLOSE(10)
C               READ HUBENY MODEL
C               READ KURUCZ MODEL
	IMODEL=0
        IF (IMODEL.EQ.1) THEN
          CALL HMODEL(INMOD,NDIM,NBOD
     P    ,VDM,VHLB,VTEP,VEKONC,VAKONC,VDENS)
	ELSE
  	  CALL AMOD(INMOD,NDIM,NBOD,TEF,GLOG
     P    ,VDM,VHLB,VTEP,VTLAK,VEKONC,VAKONC,VDENS,ABROSS)
	ENDIF
C-----------------------------------------------------------------------
C             TEMPERATURE GRADIENT dT/dR >0
C-----------------------------------------------------------------------
        DO 60 K=1,NION
          DO 50 J=1,2
	    DO 40 I=1,NBOD
	      IF (VTEP(I).GT.TEP1(K,J)) THEN
	        I12(K,J)=I
	        TEP(K,J)=VTEP(I)
		DENS(K,J)=VDENS(I)
		ROSS(K,J)=ABROSS(I)
		IF(I.EQ.1.OR.I.EQ.NBOD)THEN
		  IF(I.EQ.1)THEN
                    DTDR(K,J)=BLB1(VTEP(1),VHLB(1),VTEP(2),VHLB(2)
     P              ,VTEP(3),VHLB(3))
		  ELSE
                    DTDR(K,J)=BLB2(VTEP(NBOD-2),VHLB(NBOD-2)
     P              ,VTEP(NBOD-1),VHLB(NBOD-1),VTEP(NBOD),VHLB(NBOD))
		  ENDIF
		ELSE
                  DTDR(K,J)=BLB(VTEP(I-1),VHLB(I-1),VTEP(I),VHLB(I)
     P            ,VTEP(I+1),VHLB(I+1))
	 	ENDIF
	        I=1
	        GOTO 50
	      ENDIF
40   	    CONTINUE	
50        CONTINUE
60      CONTINUE
        WRITE(6,'(A,$)')'INPUT THE LINE LIST => '
        READ(5,'(A30)')INLIN
C----------------------------------------------------------------------
	DO 100 I=1,NION
	  CRA(I,1)=0.D0
	  CRA(I,2)=0.D0
100     CONTINUE
	IRIAD=3
        CALL ACCEL(IRIAD,INION,INLIN,NION,TEP,TEFF,HCP,
     P  DENS,ROSS,DTDR,CRA,SUMRA,SUMTOT,DSUMRA)
	IJ=1
	ITER=1
	STEP=1.D1
	SIDE=.TRUE.
  	CRA(IION,IJ)=1.D-3*SUMTOT(IION,IJ)
	IRIAD=IJ
110	CALL ACCEL(IRIAD,INION,INLIN,NION,TEP,TEFF,HCP,
     P  DENS,ROSS,DTDR,CRA,SUMRA,SUMTOT,DSUMRA)  
        WRITE(6,*)' IJ, ITER=',IJ,ITER
	WRITE(6,120)STEP,CRA(IION,IJ),DSUMRA(IION,IJ)
120 	FORMAT('STEPi, CRAi, DSUMRAi =',3E10.3)
	ITER=ITER+1
	IF(DSUMRA(IION,IJ).LT.DSUM(IION,IJ).AND.
     P  DSUMRA(IION,IJ).GT.0.8D0*DSUM(IION,IJ))THEN
	  GOTO 150
        ELSE
          IF(DSUMRA(IION,IJ).GE.DSUM(IION,IJ))THEN
            CRA(IION,IJ)=CRA(IION,IJ)/STEP
	    SIDE1=.FALSE.
	  ELSE
            CRA(IION,IJ)=CRA(IION,IJ)*STEP
            SIDE1=.TRUE.
	  ENDIF
	  IF(SIDE1.NE.SIDE)THEN
	    STEP=DSQRT(STEP)
	  ENDIF
	  SIDE=SIDE1
 	  GOTO 110	
        ENDIF
150 	CRA0(IION,IJ)=CRA(IION,IJ)
	IJ=2
	ITER=1
	STEP=1.D1
	SIDE=.TRUE.
  	CRA(IION,IJ)=1.D-3*SUMTOT(IION,IJ)
  	CRA(IION,1)=0.D0
	IRIAD=IJ
160     CALL ACCEL(IRIAD,INION,INLIN,NION,TEP,TEFF,HCP,
     P  DENS,ROSS,DTDR,CRA,SUMRA,SUMTOT,DSUMRA)  
        WRITE(6,*)' IJ, ITER=',IJ,ITER
	WRITE(6,120)STEP,CRA(IION,IJ),DSUMRA(IION,IJ)
        ITER=ITER+1
	IF(DSUMRA(IION,IJ).LT.DSUM(IION,IJ).AND.
     P  DSUMRA(IION,IJ).GT.0.8D0*DSUM(IION,IJ))THEN
	  GOTO 200
        ELSE
          IF(DSUMRA(IION,IJ).GE.DSUM(IION,IJ))THEN
            CRA(IION,IJ)=CRA(IION,IJ)/STEP
	    SIDE1=.FALSE.
	  ELSE
            CRA(IION,IJ)=CRA(IION,IJ)*STEP
            SIDE1=.TRUE.
	  ENDIF
	  IF(SIDE1.NE.SIDE)THEN
	    STEP=DSQRT(STEP)
	  ENDIF
	  SIDE=SIDE1
 	  GOTO 160	
        ENDIF
200 	CRA0(IION,IJ)=CRA(IION,IJ)
	IRIAD=3
        CALL ACCEL(IRIAD,INION,INLIN,NION,TEP,TEFF,HCP,
     P  DENS,ROSS,DTDR,CRA0,SUMRA,SUMTOT,DSUMRA)  
	STOP
	END
C-----------------------------------------------------------------------
	SUBROUTINE ACCEL(IRIAD,INION,INLIN,NION,TEP,TEFF,HCP,
     P  DENS,ROSS,DTDR,CRA,SUMRA,SUMTOT,DSUMRA)
C		INPUT:
C	IRIAD- CONTROLS THE MODE, 
C	IRIAD=1 OMITS ONLY LINES WITH RA_1<CRA_1
C       IRIAD=2 OMITS ONLY LINES WITH RA_2<CRA_2
C       IRIAD=3 OMITS LINES WITH (RA_1<CRA_1 OR RA_2<CRA_2)
C	CRA_12 -CLIPS FOR RADIATIVE ACCEL. AT T_1 AND T_2
C	FILE WITH LINELIST
C		OUTPUT:
C	DSUMRA_12 
C	SUMRA_12
C	SUMTOT_12 
C	FILES:*.ION,HLADAJ.OUT
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        CHARACTER*30 INLIN,INION
C        CHARACTER*24 A7
        DIMENSION TEP(9,2),CRA(9,2),INION(9),DSUMRA(9,2)
     P  ,SUMRA(9,2),SUMTOT(9,2),NDAT(9),NTOT(9),DTDR(9,2),RA(2),POPUL(2)
     P  ,DENS(9,2),ROSS(9,2)
        H=6.62618D-27
        C=2.997925D10
        HJED=1.66053D-24
	PI=3.14159D0
C       CONST=H*1.336D6/HCP/HJED
        OPEN(11,FILE=INLIN,STATUS='OLD')
	DO 50 I=1,NION
          OPEN(I+20,FILE=INION(I),STATUS='UNKNOWN')
          SUMRA(I,1)=0.D0
          SUMRA(I,2)=0.D0
          SUMTOT(I,1)=0.D0
          SUMTOT(I,2)=0.D0
          NDAT(I)=0
	  NTOT(I)=0
50      CONTINUE
C		ALAM- LAMBDA [NM], FREQ - FREQUENCY [1/S]
60      READ(11,*,ERR=150,END=100)ALAM,COD,GF,ELO,GLO,EUP,GUP,GR,GS,GW
     P  ,INEXT
C	ALLOWANCE FOR THE AUTOIONIZATION LINES IN THE KURUCZ LINE LIST
	IF(EUP.LT.0.D0)EUP=-EUP
	FREQ=C*1.D7/ALAM
C20      FORMAT(F10.4,2F6.2,F11.3,F4.1,F12.3,F4.1,A24)
C70      FORMAT(F10.4,F6.2,F7.3,F12.3,F5.1,F13.3,F5.1,F7.2,2F6.2,I2)
        ION=INT((COD-INT(COD))*100.D0+1.5D0)
C       	BIJ - EINSTEIN COEF.
C		POPUL =N_L/N - POPULATION OF THE LOWER LEVEL 
C		               IF PART.F.=0
C		RA - APPROXIMATE RADIATIVE ACCELERATION
        BIJ=DEXP(2.302585D0*GF)/(2.D0*GLO+1.D0)/7.484D-7*ALAM*10.D0
	DO 70 J=1,2
          POPUL(J)=DEXP(-2.3025858*ELO/8065.9D0*5039.77D0/TEP(ION,J))
     P    *(2.D0*GLO+1.D0)
          RA(J)=H/HJED/HCP/ALAM/1.D-7*BIJ*POPUL(J)
     P    *(1.D0-DEXP(-1.43871D0/TEP(ION,1)/ALAM/1.D-7))
C		WEIGHTING BY EITHER PLANCK OR MILNES FLUX
          IF(TEP(ION,J).LT.TEFF)THEN
            RA(J)=RA(J)*PI*PLANCK(FREQ,TEFF,1)
          ELSE
            CALL DERIV(FREQ,TEP(ION,J),DBT)
            CALL OPAC (FREQ,TEP(ION,J),DENS(ION,J),CHI
     P      ,ROSS(ION,J))	  
            RA(J)=RA(J)*4.D0*PI*DBT*DTDR(ION,J)/3.D0/CHI
          ENDIF
70 	CONTINUE
C		CHOOSING IMPORTANT LINES
	IF (IRIAD.EQ.3)THEN
          IF(RA(1).GT.CRA(ION,1).OR.RA(2).GT.CRA(ION,2))THEN
            WRITE(ION+20,130)ALAM,COD,GF,ELO,GLO,EUP,GUP,GR,GS,GW,INEXT
     P	    ,RA(1),RA(2)
            SUMRA(ION,1)=SUMRA(ION,1)+RA(1)
            SUMRA(ION,2)=SUMRA(ION,2)+RA(2)
            NDAT(ION)=NDAT(ION)+1
          ENDIF
        ENDIF
	IF (IRIAD.EQ.1)THEN
          IF(RA(1).GT.CRA(ION,1))THEN
            WRITE(ION+20,130)ALAM,COD,GF,ELO,GLO,EUP,GUP,GR,GS,GW,INEXT
     P	    ,RA(1),RA(2)
            SUMRA(ION,1)=SUMRA(ION,1)+RA(1)
            SUMRA(ION,2)=SUMRA(ION,2)+RA(2)
            NDAT(ION)=NDAT(ION)+1
          ENDIF
        ENDIF
	IF (IRIAD.EQ.2)THEN
          IF(RA(2).GT.CRA(ION,2))THEN
            WRITE(ION+20,130)ALAM,COD,GF,ELO,GLO,EUP,GUP,GR,GS,GW,INEXT
     P	    ,RA(1),RA(2)
            SUMRA(ION,1)=SUMRA(ION,1)+RA(1)
            SUMRA(ION,2)=SUMRA(ION,2)+RA(2)
            NDAT(ION)=NDAT(ION)+1
          ENDIF
        ENDIF
        SUMTOT(ION,1)=SUMTOT(ION,1)+RA(1)
        SUMTOT(ION,2)=SUMTOT(ION,2)+RA(2)
        NTOT(ION)=NTOT(ION)+1
        GOTO 60
100     CLOSE(11)
        OPEN(12,FILE='hladaj.out',STATUS='UNKNOWN')
        WRITE(12,*)' ION, NLINE_TOT, NLINE_SELECTED, SUMRA_12,',
     P' CRA_12,            DSUMRA_12'
        DO 110 I=1,NION
          CLOSE(I+20)
	  DSUMRA(I,1)=(SUMTOT(I,1)-SUMRA(I,1))/SUMTOT(I,1)
	  DSUMRA(I,2)=(SUMTOT(I,2)-SUMRA(I,2))/SUMTOT(I,2)
          WRITE(12,140)I,NTOT(I),NDAT(I),SUMTOT(I,1),SUMTOT(I,2),
     P    CRA(I,1),CRA(I,2),DSUMRA(I,1),DSUMRA(I,2)
110     CONTINUE
        CLOSE(12)
130     FORMAT(F10.4,F6.2,1X,F7.3,F12.3,F5.1,F13.3,F5.1,3F7.2,I2
     P  ,2X,2E10.2)
C30      FORMAT(F10.4,2F6.2,F11.3,F4.1,F12.3,F4.1,A24,1X,2E11.3)
140     FORMAT(I2,1X,2I5,6E10.2)
	GOTO 160
150	WRITE(6,*)' FORMAT ERROR'
  	PAUSE
160     CONTINUE
	RETURN
        END
C-----------------------------------------------------------------------
        DOUBLE PRECISION FUNCTION PLANCK(FREQ,TEP,IER)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       FUNCTION  PLANCK  FOR BLACK BODY RADIATION
C               IF   IER<0  PLANCK IS INTENSITY IN [??/CM]
C                           FREQ IN [CM]
C                    IER=0  PLANCK IS INTENSITY IN [??/ANGSTROM]
C                           FREQ IN [ANGSTROM]
C                    IER>0  PLANCK IS INTENSITY IN [??/(1/SECOND)]
C                           FREQ IN [1/S]
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        IF(IER)10,20,30
C10      WRITE(*,*)'EXP',1.4D0/FREQ/TEP
10       PLANCK=1.19106D-5/FREQ**5./(DEXP(1.43879D0/FREQ/TEP)-1.)
         RETURN
C20      WRITE(*,*)'EXP',1.4D8/FREQ/TEP
20       PLANCK=1.19106D27/FREQ**5./(DEXP(1.43879D8/FREQ/TEP)-1.)
         RETURN
C30      WRITE(*,*)'EXP',4.7D-11*FREQ/TEP
30       PLANCK=1.4745D-47*FREQ*FREQ*FREQ/(DEXP(4.7993D-11*FREQ/TEP)-1.)
         RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE DERIV(FREQ,TEP,DER)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       PARCIAL DERIVATION OF THE PLANCK FUNCTION AFTER THE TEMPERATURE
C       IN [CGS], B_FREQUENCY
C       INPUT:  FREQ  -FREQUENCY
C               TEP   -TEMPERATURE
C       OUTPUT: DER   -PARC.DERIVATION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        H=6.626196D-27
        C=2.997925D10
        BK=1.380622D-16
        POM=H*FREQ/BK/TEP
C       WRITE(*,*)'POM',POM
        DER=2.D0*H*FREQ*FREQ*FREQ/C/C*POM/TEP
        POM1=DEXP(POM)
        DER=DER*POM1/(POM1-1.D0)/(POM1-1.D0)
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE AMOD(INN,NM1,NM,TEF,GLOG
     P  ,VDM,VHLB,VTEP,VTLAK,VEKONC,VAKONC,VDENS,ABROSS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION VHLB(NM1),VAKONC(NM1),VEKONC(NM1),VTLAK(NM1)
     p  ,VTEP(NM1),VDM(NM1),VDENS(NM1),ABROSS(NM1)
        CHARACTER*30 INN
C
C             MODEL OF THE ATMOSPHERE (NEW KURUCZ)
C
C       DM - MASS DEPTH COORDINATE
C       HLB - GEOMETRICAL DEPTH
C       TEP - TEMPERATURE
C       TLAK - GASS PRESSURE
C       EKONC - ELECTRON NUMBER DENSITY
C       AKONC - (ALL) ATOM NUMBER DENSITY
C       DENS - DENSITY
C	ABROSS - ROSS.MEAN OPACITY [CM^2/G]
C
        OPEN(13,FILE=INN,STATUS='OLD')
        READ(13,30) TEF,GLOG
        READ(13,35) NM
30      FORMAT(4X,F8.0,9X,F8.5)
35      FORMAT(/////////////////////10X,I3)
        BOL=1.38062D-16
C               WMM=SUM_e (M_e*ABUNDANCE_e)  IS MEAN ATOM MASS
C       ABUNDANCE_e IS N_e/AKONC
        WMM=2.2034D-24
        VHLB(1)=0.D0
        DO 40 I=1,NM
          READ(13,*)VDM(I),VTEP(I),VTLAK(I),VEKONC(I),ABROSS(I)
          VAKONC(I)=VTLAK(I)/VTEP(I)/BOL
          VAKONC(I)=VAKONC(I)-VEKONC(I)
          VDENS(I)=VAKONC(I)*WMM
          IF(I.GT.1) THEN
            DELTA=2.D0*(VDM(I)-VDM(I-1))/(VDENS(I)+VDENS(I-1))
            VHLB(I)=DELTA+VHLB(I-1)
          ENDIF
40      CONTINUE
        CLOSE(13)
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION BLB(X,XH,Y,YH,Z,ZH)
C       GRADIENT TAKING INTO ACCOUNT 2. TERMS OF THE TAYLOR.EXPANSION
C	X,Y,Z ARE VALUES OF THE FUNCTION AT XH<YH<ZH
C	BLB - GRADIENT AT YH
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        BLB=((YH-XH)*(YH-XH)*Z-((YH-XH)*(YH-XH)
     P  -(ZH-YH)*(ZH-YH))*Y-(ZH-YH)*(ZH-YH)*X)/((ZH-XH)*(ZH-YH)*(YH-XH))
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION BLB1(X,XH,Y,YH,Z,ZH)
C             GRADIENT IN THE FIRST BOUNDARY POINT
C       X,Y,Z ARE VALUES OF THE FUNCTION AT XH<YH<ZH
C       BLB1 - GRADIENT AT XH
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        BLB1=(((YH-XH)*(YH-XH)-(ZH-XH)*(ZH-XH))*X
     P  +(ZH-XH)*(ZH-XH)*Y-(YH-XH)*(YH-XH)*Z)/((ZH-XH)*(YH-XH)*(ZH-YH))
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION BLB2(X,XH,Y,YH,Z,ZH)
C             GRADIENT IN THE LAST BOUNDARY POINT
C       X,Y,Z ARE VALUES OF THE FUNCTION AT XH<YH<ZH
C       BLB2 - GRADIENT AT ZH
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        BLB2=(((ZH-XH)*(ZH-XH)-(ZH-YH)*(ZH-YH))*Z
     P  -(ZH-XH)*(ZH-XH)*Y+(ZH-YH)*(ZH-YH)*X)/((ZH-XH)*(YH-XH)*(ZH-YH))
        RETURN
        END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        SUBROUTINE OPAC (FREQ,TEP,DENS,CHI,ABROSS)
C       TO ESTIMATE MONOCHROM. CHI_{\NU} OPACITY [CM^-1]
C	AFTER BORSENBERG ET AL., 1979, AA 76, 287 
C       FREQ - FREQUENCY [1/S]
C       TEP - TEMPERATURE [K]
C       DENS - DENSITY [CGS]
C       ABROSS - ROSSELAND MEAN OPACITY [CM^2/G]
C       OPAC - MONOCHROM. OPACITY [CM^-1]
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        PLANK=6.626196D-27
        BOL=1.38062D-16
        T4=TEP*1.D-4
        AK10=2.D0*DEXP(8.79D0/T4)
        IF(T4.GT.2.D0) THEN
          AK1=DMAX1(5.D0*2.D0**(15.D0/T4-4.D0),1.D0)*ABROSS
          AK0=AK1/AK10
        ELSE
          AK0=20.D0*(1.8D0-0.4D0*T4)*(T4/15.D0)**2.D0*ABROSS
          AK1=AK0*AK10
        ENDIF
        HNU=PLANK*FREQ
        U=HNU/BOL/TEP
C       IN [EV]
        HNU=6.241507D11*HNU
        IF(HNU.GT.13.598D0)THEN
          CHI=AK1
        ELSE
          CHI=AK0*(13.598D0/HNU)*(13.598D0/HNU)
        ENDIF
C       IN [CM^-1]
        CHI=CHI*DENS
C        WRITE(2,*)' U , OPAC',U,CHI
	RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE HMODEL(INN,NM1,NDPTH
     P  ,DEPTH,HLB,TEMP,ELEC,AKONC,DENS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION DEPTH(NM1),HLB(NM1),TEMP(NM1),ELEC(NM1),
     P  AKONC(NM1),DENS(NM1),X(500)   
        CHARACTER*30 INN
C
C             MODEL OF THE ATMOSPHERE (HUBENY)
C
C       DEPTH - MASS DEPTH COORDINATE 
C       TEMP - TEMPERATURE
C       ELEC - ELECTRON NUMBER DENSITY [CGS]
C       AKONC - (ALL) ATOM NUMBER DENSITY [CGS]
C       DENS - DENSITY [CGS]
C
C               WMM=SUM_e (M_e*ABUNDANCE_e)  IS THE MEAN ATOM MASS
C       WHERE ABUNDANCE_e IS N_e/AKONC
C       FOR 90% H + 10 % HE  :
        WMM=2.2034D-24   
        OPEN(13,FILE=INN,STATUS='OLD')
        HLB(1)=0.D0
        READ(13,*) NDPTH,NUMPAR
        READ(13,*) (DEPTH(I),I=1,NDPTH)
        DO 30 ID=1,NDPTH 
          READ(13,*) (X(I),I=1,NUMPAR)
          TEMP(ID)=X(1)  
          ELEC(ID)=X(2)  
          DENS(ID)=X(3)  
          AKONC(ID)=DENS(ID)/WMM
          IF(ID.GT.1) THEN
            DELTA=2.D0*(DEPTH(I)-DEPTH(I-1))/(DENS(I)+DENS(I-1))
            HLB(I)=DELTA+HLB(I-1)
          ENDIF
C          write(9,'(4e11.4)')depth(id),temp(id),elec(id),dens(id)
30      CONTINUE         
        CLOSE(13)         
        RETURN           
        END       
